I think alot can be achieved with the postcommand function. Hope you don't mind but i took your idea and gave it a crack....
Firstly i created a form with the wheel as the background. I created a public property on the form which is the id of the command to issue:
Public CommandToIssue As RevitCommandId
I then created transparent picture boxes over the various icons. Clicking on a picturebox asigns a command id and closes the form:
Private Sub PictureBox2_Click(sender As Object, e As EventArgs) Handles PictureBox2.Click
CommandToIssue = RevitCommandId.LookupPostableCommandId(PostableCommand.StructuralColumn)
Close()
End Sub
Under the forms show event i added code to locate the form at the mouses current position:
Private Sub WheelForm_Shown(sender As Object, e As EventArgs) Handles Me.Shown
Location = New System.Drawing.Point(CInt(MousePosition.X - (Me.Width / 2)), CInt(MousePosition.Y - (Me.Width / 2)))
End Sub
Finally I setup a command to display the wheel, and post the command:
Option Strict On
Option Explicit On
Imports Autodesk.Revit.Attributes
Imports Autodesk.Revit.UI
Imports BrevitTools.UI.Wheel
<Transaction(TransactionMode.Manual)> _
Public Class Wheel
Implements IExternalCommand
Public Function Execute(cmdData As ExternalCommandData, ByRef message As String, elements As Autodesk.Revit.DB.ElementSet) As Result Implements IExternalCommand.Execute
Dim form As New WheelForm
form.ShowDialog()
If form.CommandToIssue IsNot Nothing Then
cmdData.Application.PostCommand(form.CommandToIssue)
End If
Return Result.Succeeded
End Function
End Class
To display the wheel inside revit I assigned a shotcut key (ww)
Here is link to a video of it in action:
https://www.youtube.com/watch?v=lYrpJe2484E&feature=youtu.be
I think there is loads of potential for this. You could easily add code to check what elements are preselected and then display a contextual wheel.
Brett.